// Generated by ReScript, PLEASE EDIT WITH CARE

import * as Fs from "fs";
import * as Js_exn from "rescript/lib/es6/js_exn.js";
import * as Readline from "readline";
import * as RescriptCore from "@rescript/core/src/RescriptCore.mjs";
import * as RescriptTools from "@rescript/tools/npm/RescriptTools.mjs";
import * as Caml_js_exceptions from "rescript/lib/es6/caml_js_exceptions.js";
import * as Nodechild_process from "node:child_process";

function readFirstLine(filePath) {
  var readStream = Fs.createReadStream(filePath);
  var rl = Readline.createInterface({
        input: readStream,
        crlfDelay: Infinity
      });
  return new Promise((function (resolve, _reject) {
                rl.on("line", (function (line) {
                        rl.close();
                        readStream.destroy();
                        resolve({
                              TAG: "Ok",
                              _0: line
                            });
                      }));
                rl.on("error", (function (_err) {
                        resolve({
                              TAG: "Error",
                              _0: undefined
                            });
                      }));
              }));
}

var ReadFile = {
  readFirstLine: readFirstLine
};

async function findContentInFile(filePath, tags) {
  try {
    return JSON.parse(Nodechild_process.execFileSync(RescriptTools.getBinaryPath(), [
                      "extract-embedded",
                      tags.map(function (t) {
                              return t.slice(1);
                            }).join(","),
                      filePath
                    ]).toString());
  }
  catch (raw_e){
    var e = Caml_js_exceptions.internalToOCamlException(raw_e);
    if (e.RE_EXN_ID === Js_exn.$$Error) {
      console.error(e._1);
      return RescriptCore.panic("Failed");
    }
    throw e;
  }
}

async function extractContentInFile(filePath, tags) {
  return await findContentInFile(filePath, tags);
}

export {
  ReadFile ,
  findContentInFile ,
  extractContentInFile ,
}
/* fs Not a pure module */
